package com.milaboratory.mitcr.clonegenerator;

import com.milaboratory.core.sequence.NucleotideSQPair;
import com.milaboratory.core.sequence.quality.SequenceQualityPhred;
import com.milaboratory.mitcr.cdrextraction.CDR3ExtractionResult;

import static com.milaboratory.mitcr.clonegenerator.AverageQualityCalculator.convertValues;
import static com.milaboratory.mitcr.clonegenerator.AverageQualityCalculator.nextValues;

public abstract class AccumulatorCloneAvrg extends AccumulatorClone {
    public AccumulatorCloneAvrg(int id, NucleotideSQPair cdr3, boolean saveLinks) {
        super(id, cdr3, saveLinks);
    }

    @Override
    synchronized void include(CDR3ExtractionResult result, boolean additional) {
        super.include(result, additional);

        //Returns a link to the underlying byte array, so it could be used here for
        //accumulation of average values
        //IMPORTANT: because of this quality object of clone is invalid before clone compilation
        final byte[] avrgStorage = ((SequenceQualityPhred) cdr3.getQuality()).getRawData();

        //Adding observed values
        nextValues(avrgStorage, count - 1,
                ((SequenceQualityPhred) result.getCDR3().getQuality()).getRawData());
    }

    @Override
    void compile(float barcodeAggregationFactor) {
        //Now the quality object is valid
        convertValues(((SequenceQualityPhred) cdr3.getQuality()).getRawData());
    }
}
